import request from '@/utils/request';
import type { ApiResult } from '@/api/index';
import type {
  LoginParam,
  LoginResult,
  CaptchaResult,
  SmsCaptchaResult
} from './model';
import {saveStorageByLoginUser, SERVER_API_URL} from "@/utils/server";

/**
 * 登录
 */
export async function login(data: LoginParam) {
  const res = await request.post<ApiResult<LoginResult>>(
    SERVER_API_URL + '/login',
    data
  );
  if (res.code === 0) {
    // setToken(res.data.data?.access_token, data.remember);
    if (res.data?.user) {
      const user = res.data?.user;
      localStorage.setItem('TenantId', String(user.tenantId));
      localStorage.setItem('UserId', String(user.userId));
    }

    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取验证码
 */
export async function getCaptcha() {
  const res = await request.get<ApiResult<CaptchaResult>>(
    SERVER_API_URL + '/captcha',
    {}
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function loginBySms(data: LoginParam) {
  const res = await request.post<ApiResult<LoginResult>>(
    SERVER_API_URL + '/loginBySms',
    data
  );
  if (res.code === 0) {
    if(res.data?.user){
      saveStorageByLoginUser(`${res.data?.access_token}`, res.data?.user)
    }
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 发送短信验证码
 */
export async function sendSmsCaptcha(data: LoginParam) {
  const res = await request.post<ApiResult<SmsCaptchaResult>>(
    SERVER_API_URL + '/sendSmsCaptcha',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

export async function getOpenId(data: any){
  const res = request.post<ApiResult<LoginResult>>(
    SERVER_API_URL + '/wx-login/getOpenId',
    data
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function loginByOpenId(data:any){
  const res = request.post<ApiResult<LoginResult>>(
    SERVER_API_URL + '/wx-login/loginByOpenId',
    data
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
/**
 * 登录
 */
export async function remoteLogin(data: LoginParam) {
  const res = await request.post<ApiResult<LoginResult>>(
    'https://open.gxwebsoft.com/api/login',
    data
  );
  if (res.code === 0) {
    // setToken(res.data.data?.access_token, data.remember);
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 获取企业微信登录链接
 */
export async function getWxWorkQrConnect(data: any) {
  const res = await request.post<ApiResult<unknown>>(
    '/wx-work',
    data
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

export async function loginMpWxMobile(data: {
  refereeId: number;
  gradeId: number;
  code: any;
  sceneType: string;
  comments: string;
  encryptedData: any;
  tenantId: string;
  iv: any;
  notVerifyPhone: boolean
}) {
  const res = request.post<ApiResult<unknown>>(SERVER_API_URL + '/wx-login/loginByMpWxPhone', data);
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
